<template>
  <div>
    <v-btn
      class="ma-2"
      :loading="loading"
      :disabled="loading || errorStatus"
      fab
      dark
      small
      color="primary"
      @click="emitUpdate"
    >
      <v-icon>fas fa-equals</v-icon>
    </v-btn>
    <v-btn
      class="mx-2"
      fab
      dark
      small
      color="primary"
      @click="removePoint"
      depressed
      v-if="getCountPoint != 0"
    >
      <v-icon>fas fa-minus</v-icon>
    </v-btn>
    <v-btn v-else class="mx-2" fab dark small color="danger" depressed>
      <v-icon>fas fa-minus</v-icon>
    </v-btn>

    <v-btn
      class="mx-2"
      fab
      dark
      small
      color="primary"
      @click="addPoint"
      depressed
      v-if="getCountPoint <= 5"
    >
      <v-icon>fas fa-plus</v-icon>
    </v-btn>
    <v-btn v-else class="mx-2" fab dark small color="danger" depressed>
      <v-icon>fas fa-plus</v-icon>
    </v-btn>

    <div class="container ">
      <pointPanel
        v-for="point in getPoints"
        :key="point.id"
        :propnumber="point.id"
        :proplongitude="point.longitude"
        :proplatitude="point.latitude"
        @error="error"
        @updateInput="updateInputpoint"
      >
      </pointPanel>
    </div>
  </div>
</template>
<script>
import { mapGetters, mapActions } from "vuex";
import { axiosAPI } from "../axios";
import pointPanel from "./Point";
export default {
  props: ["point1", "point2"],
  components: { pointPanel },
  data: () => ({
    loading: false,
    errorPoint: []
  }),
  computed: {
    ...mapGetters(["getCountPoint", "getPoints"]),
    errorStatus: function() {
      return this.errorPoint.length > 0;
    }
  },

  methods: {
    ...mapActions(["actionAddPoint", "actionRemovePoint", "actionUpdatePoint"]),

    addPoint() {
      this.actionAddPoint();
    },
    removePoint() {
      this.actionRemovePoint();

      let id = this.errorPoint.findIndex(el => {
        console.log(el.id);
        return el.id === this.getPoints.length;
      });
      if (id != -1) {
        this.errorPoint.splice(id, 1);
      }
    },
    error(value) {
      if (value.isError) {
        this.errorPoint.push(value);
      } else {
        let id = this.errorPoint.findIndex(el => el.id === value.id);
        this.errorPoint.splice(id, 1);
      }
    },
    updateInputpoint(event) {
      this.actionUpdatePoint(event);
    },

    async emitUpdate() {
      this.loading = true;

      try {
        let score = 0;
        for (let i = 0; i < this.getPoints.length - 1; i++) {
          let payload = {
            point1: this.getPoints[i],
            point2: this.getPoints[i + 1]
          };
          let { data, status } = await axiosAPI.post("licz", payload);
          if (status === 200 && data.status === "ok") {
            score += data.score;
          } else {
            console.log(`Check log: ${data.status} ${status} `);
          }
        }
        this.$emit("update", score);
      } catch (error) {
        console.log("ERROR: ", error);
      } finally {
        this.loading = false;
      }
    }
  }
};
</script>
<style scoped>
.container {
  display: flex;
  flex-wrap: wrap;
  max-height: 800px;
  flex-direction: column;
}
</style>
